/// Created by Arsenii Kirillov
 
#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include "testlib.h"
//#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
#ifndef LOCAL
#  define cerr __get_ce
#endif
 
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
 
/*
using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;
//*/
 
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rndd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }
 
 
int main(int argc, char* argv[]) {
#ifdef LOCAL
	clock_t start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
 
	int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    int k = atoi(argv[3]);
    int p = atoi(argv[4]);
    int q = atoi(argv[5]);
    vector<vector<char>> s(n, vector<char>(m, '.'));
    vector<pair<int, int>> v1, v2;
    for (int i = 0; i < n; i++) {
    	for (int j = 0; j < m; j++) {
    		if (rnd.next(1, q) <= p) {
    			s[i][j] = '#';
    			v1.push_back({i, j});
    		}
    		else
    			v2.push_back({i, j});
    	}
    }
    shuffle(all(v2));
    s[v2[0].first][v2[0].second] = 'S';
    s[v2[1].first][v2[1].second] = 'F';
    cout << n << " " << m << " " << k << "\n";
    for (int i = 0; i < n; i++) {
    	for (int j = 0; j < m; j++)
    		cout << s[i][j];
    	cout << "\n";
    }
    for (int i = 0; i < k; i++) {
    	int j = rnd.next(0, sz(v1) - 1);
    	cout << v1[j].first + 1 << " " << v1[j].second + 1 << "\n";
    }
 
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}