#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

int MAXN = 100;
int MAXK[4] = {100, 0, 5, 100};

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);
	auto gr = validator.group().empty() ? 0 : validator.group()[0] - '0';

	int n = inf.readInt(1, MAXN, "n");
	inf.readSpace();
	int m = inf.readInt(1, MAXN, "m");
	inf.readSpace();
	int k = inf.readInt(0, MAXK[gr], "k");
	inf.readEoln();
	vector<string> s(n);
	int cnt_s = 0, cnt_f = 0;
	for (int i = 0; i < n; i++) {
		s[i] = inf.readToken(format("[.#SF]{%d}", m), format("s_%d", i + 1));
		for (int j = 0; j < m; j++) {
			if (s[i][j] == 'S')
				cnt_s++;
			if (s[i][j] == 'F')
				cnt_f++;
		}
		inf.readEoln();
	}
	ensure(cnt_s == 1);
	ensure(cnt_f == 1);
	for (int i = 0; i < k; i++) {
		int x = inf.readInt(1, n, format("x_%d", i + 1));
		inf.readSpace();
		int y = inf.readInt(1, m, format("y_%d", i + 1));
		inf.readEoln();
		ensuref(s[x - 1][y - 1] == '#', "Stone not in wall");
	}
	inf.readEof();
	return 0;
}