// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

const int MAXV = 1'000'000'000;

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = opt<int>(1);
	int add = opt<int>(2);
	int prob = opt<int>(3);
	int from = opt<int>(4);

	deque<int> arr = {from};
	int cur_val = from;
	int cnt = 1;
	while (szof(arr) < n) {
		int cur_add = min((cnt & 1) + rnd.next(0, add) * 2, n - szof(arr));
		for (int i = 0; i < cur_add; ++i) {
			++cnt;
			if (rnd.next(100) < prob) {
				arr.push_front(cur_val);
			} else {
				arr.push_back(cur_val);
			}
		}
		// assert(cnt % 2 == 0);
		cnt /= 2;
		++cur_val;
	}

	cout << n << "\n";
	for (int i = 0; i < n; ++i) {
		cout << arr[i];
		if (i < n - 1) {
			cout << " ";
		}
	}
	cout << "\n";

	return 0;
}