/// Created by Arsenii Kirillov
 
#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include "testlib.h"
//#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
#ifndef LOCAL
#  define cerr __get_ce
#endif
 
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
 
/*
using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;
//*/
 
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rndd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }
 
 
int main(int argc, char* argv[]) {
#ifdef LOCAL
	clock_t start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
 
	int n = atoi(argv[1]);
	if ((n & 1) == 0)
		n--;
    int m = atoi(argv[2]);
    if (m == 1)
    	m++;
    int k = atoi(argv[3]);
    vector<vector<char>> s(n, vector<char>(m, '.'));
    vector<int> x(k), y(k);
    for (int i = 1; i < n; i += 2) {
    	fill(all(s[i]), '#');
    	if (i & 2)
    		s[i][0] = '.';
    	else
    		s[i][m - 1] = '.';
    }
    int last = 0;
    if ((n - 2) & 2)
    	last = m - 1;
    s[0][0] = '#';
    s[n - 1][last] = '#';
    s[0][1] = 'S';
    s[n - 1][last == 0 ? 1 : last - 1] = 'F';
    for (int i = 0; i < k; i++) {
    	if (i & 1) {
    		x[i] = 0;
    		y[i] = 0;
    	} else {
    		x[i] = n - 1;
    		y[i] = last;
    	}
    }
    //*
    if (rnd.next(0, 1)) {
    	for (int i = 0; i < n - 1 - i; i++)
    		for (int j = 0; j < m; j++)
    			swap(s[i][j], s[n - 1 - i][j]);
    	for (int i = 0; i < k; i++)
    		x[i] = n - 1 - x[i];
    }
    if (rnd.next(0, 1)) {
    	for (int i = 0; i < n; i++)
    		for (int j = 0; j < m - 1 - j; j++)
    			swap(s[i][j], s[i][m - 1 - j]);
    	for (int i = 0; i < k; i++)
    		y[i] = m - 1 - y[i];
    }
    if (rnd.next(0, 1)) {
    	vector<vector<char>> ss(m, vector<char>(n));
    	for (int i = 0; i < n; i++)
    		for (int j = 0; j < m; j++)
    			ss[j][i] = s[i][j];
    	s = ss;
    	for (int i = 0; i < k; i++)
    		swap(x[i], y[i]);
    	swap(n, m);
    }
    //*/
    cout << n << " " << m << " " << k << "\n";
    for (int i = 0; i < n; i++) {
    	for (int j = 0; j < m; j++)
    		cout << s[i][j];
    	cout << "\n";
    }
    for (int i = 0; i < k; i++) {
    	cout << x[i] + 1 << " " << y[i] + 1 << "\n";
    }
 
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}